#ifndef __KRB4_H
#define __KRB4_H
/***************************************************************************
 *                                  _   _ ____  _
 *  Project                     ___| | | |  _ \| |
 *                             / __| | | | |_) | |
 *                            | (__| |_| |  _ <| |___
 *                             \___|\___/|_| \_\_____|
 *
 * Copyright (C) 1998 - 2005, Daniel Stenberg, <daniel@haxx.se>, et al.
 *
 * This software is licensed as described in the file COPYING, which
 * you should have received as part of this distribution. The terms
 * are also available at http://curl.haxx.se/docs/copyright.html.
 *
 * You may opt to use, copy, modify, merge, publish, distribute and/or sell
 * copies of the Software, and permit persons to whom the Software is
 * furnished to do so, under the terms of the COPYING file.
 *
 * This software is distributed on an "AS IS" basis, WITHOUT WARRANTY OF ANY
 * KIND, either express or implied.
 *
 * $Id: sdm/scs/src/curllib/krb4.h 1.1 2006/11/09 18:03:30CET Goettlicher Harald (AA-DG/ESW4) * (GO82PL) OK  $
 ***************************************************************************/

struct Curl_sec_client_mech {
  const char *name;
  size_t size;
  long (*init)(void *);
  long (*auth)(void *, struct connectdata *);
  void (*end)(void *);
  long (*check_prot)(void *, long);
  long (*overhead)(void *, long, long);
  long (*encode)(void *, void*, long, long, void**, struct connectdata *);
  long (*decode)(void *, void*, long, long, struct connectdata *);
};


#define AUTH_OK         0
#define AUTH_CONTINUE   1
#define AUTH_ERROR      2

extern struct Curl_sec_client_mech Curl_krb4_client_mech;

CURLcode Curl_krb_kauth(struct connectdata *conn);
long Curl_sec_fflush_fd(struct connectdata *conn, long fd);
long Curl_sec_fprintf (struct connectdata *, FILE *, const char *, ...);
long Curl_sec_getc (struct connectdata *conn, FILE *);
long Curl_sec_putc (struct connectdata *conn, long, FILE *);
long Curl_sec_read (struct connectdata *conn, long, void *, long);
long Curl_sec_read_msg (struct connectdata *conn, char *, long);

long Curl_sec_vfprintf(struct connectdata *, FILE *, const char *, va_list);
long Curl_sec_fprintf2(struct connectdata *conn, FILE *f, const char *fmt, ...);
long Curl_sec_vfprintf2(struct connectdata *conn, FILE *, const char *, va_list);
long Curl_sec_write (struct connectdata *conn, long, char *, long);

void Curl_sec_end (struct connectdata *);
long Curl_sec_login (struct connectdata *);
void Curl_sec_prot (long, char **);
long Curl_sec_request_prot (struct connectdata *conn, const char *level);
void Curl_sec_set_protection_level(struct connectdata *conn);
void Curl_sec_status (void);

enum protection_level Curl_set_command_prot(struct connectdata *,
                                            enum protection_level);


#endif
